import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

import greenfoot.core.WorldHandler;   
import java.awt.Cursor;  
import java.awt.Point;  
import java.awt.Toolkit;
/**
 * Write a description of class Worldy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Worldy extends World {
    int[][] board = new int[21][22];
    boolean selected = false;
    int[] select = {100, 100};
    int turn = 1;
    
    public Worldy() {
        super(21, 22, 20);
        for(int x = 0; x < board.length; x++) {
            for(int y = 0; y < board[0].length; y++) {
                if((x*y)%3%2==0) {
                    if(y < 10) board[x][y] = 1;
                    if(y >= 12) board[x][y] = 2;
                }
            }
        }
        updateImage();
    }
    
    public void updateImage() {
        getBackground().setColor(new Color(230, 230, 230));
        getBackground().fill();
        for(int x = 0; x < board.length; x++) {
            for(int y = 0; y < board[0].length; y++) {
                if(board[x][y] == 0) getBackground().setColor(Color.WHITE);
                else if(board[x][y] == 1) getBackground().setColor(Color.BLUE);
                else if(board[x][y] == 2) getBackground().setColor(Color.RED);
                getBackground().fillRect(x*20+1, y*20+1, 18, 18);
            }
        }
        if(turn == 1) getBackground().setColor(Color.RED);
        else getBackground().setColor(Color.BLUE);
        getBackground().drawRect(select[0]*20, select[1]*20, 19, 19);
        getBackground().setColor(Color.WHITE);
        getBackground().drawRect(select[0]*20+1, select[1]*20+1, 17, 17);
        if(selected) {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            getBackground().setColor(Color.GREEN);
            getBackground().drawRect(mouse.getX()*20, mouse.getY()*20, 19, 19);
            getBackground().setColor(Color.WHITE);
            getBackground().drawRect(mouse.getX()*20+1, mouse.getY()*20+1, 17, 17);
        }
        //GreenfootImage cursor = new GreenfootImage(16, 16);
        //if(turn==1) cursor.setColor(Color.BLUE);
        //else cursor.setColor(Color.RED);
        //cursor.fillPolygon(new int[] {0, 0, 15}, new int[] {15, 0, 0}, 3);
        //cursor.setColor(Color.WHITE);
        //cursor.drawPolygon(new int[] {0, 0, 15}, new int[] {15, 0, 0}, 3);
    }
    
    public void act() {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if(mouse!=null) {
            if(selected && Greenfoot.mouseClicked(null)) {
                int x = mouse.getX();
                int y = mouse.getY();
                if(x==select[0]-2 && y==select[1] && board[x][y]==0 && board[x+1][y]!=0) {
                    board[x][y] = turn;
                    if(board[x+1][y]==(turn%2)+1 || (board[x+1][y]==turn&&Greenfoot.getRandomNumber(2)!=0)) board[x+1][y] = 0;
                    board[x+2][y] = 0;
                    turn = (turn%2)+1;
                } else if(x==select[0]+2 && y==select[1] && board[x][y]==0 && board[x-1][y]!=0) {
                    board[x][y] = turn;
                    if(board[x-1][y]==(turn%2)+1 || (board[x-1][y]==turn&&Greenfoot.getRandomNumber(2)!=0)) board[x-1][y] = 0;
                    board[x-2][y] = 0;
                    turn = (turn%2)+1;
                } else if(x==select[0] && y==select[1]-2 && board[x][y]==0 && board[x][y+1]!=0) {
                    board[x][y] = turn;
                    if(board[x][y+1]==(turn%2)+1 || (board[x][y+1]==turn&&Greenfoot.getRandomNumber(2)!=0)) board[x][y+1] = 0;
                    board[x][y+2] = 0;
                    turn = (turn%2)+1;
                } else if(x==select[0] && y==select[1]+2 && board[x][y]==0 && board[x][y-1]!=0) {
                    board[x][y] = turn;
                    if(board[x][y-1]==(turn%2)+1 || (board[x][y-1]==turn&&Greenfoot.getRandomNumber(2)!=0)) board[x][y-1] = 0;
                    board[x][y-2] = 0;
                    turn = (turn%2)+1;
                }
                select[0] = 100;
                selected = false;
            } else if(mouse!=null && mouse.getX() < 21 && mouse.getY() < 22 && !selected && board[mouse.getX()][mouse.getY()]==turn) {
                if(Greenfoot.mouseClicked(null)) selected = true;
                select[0] = mouse.getX();
                select[1] = mouse.getY();
            }
            updateImage();
        }
    }
}
